<template>
	<div class="container">
		<FilterTodos @filterTodos="filterTodos"/>
		<AddTodo @submitTodo="submitTodo" />
		<Todos :allTodos="allTodos" @updateTodo="updateTodo" @deleteTodo="deleteTodo"/>
	</div>
</template>

<script>
import Todos from './components/Todos.vue';
import AddTodo from './components/AddTodo.vue';
import FilterTodos from './components/FilterTodos.vue';
import axios from 'axios';

export default {
	name: 'App',
	components: {
		Todos,
		AddTodo,
		FilterTodos,
	},
	data() {
		return {
			allTodos: [],
		};
	},
	created() {
		this.fetchTodos();
	},
	methods: {
		async fetchTodos() {
			const response = await axios.get('https://jsonplaceholder.typicode.com/todos/?_limit=5');
			this.allTodos = response.data;
		},

		async submitTodo(title) {
			const response = await axios.post('https://jsonplaceholder.typicode.com/todos', {
				title: title,
				completed: false,
			});

			this.allTodos.unshift(response.data);
		},
		async updateTodo(updateTodo) {
			await axios.put(`https://jsonplaceholder.typicode.com/todos/${updateTodo.id}`, updateTodo);
      const index = this.allTodos.findIndex(todo => todo.id === updateTodo.id);
      this.allTodos.splice(index, 1, updateTodo);
		},
    async deleteTodo(id){
      await axios.delete(`https://jsonplaceholder.typicode.com/todos/${id}`);
      this.allTodos = this.allTodos.filter(todo => todo.id !== id);
    },
    async filterTodos(event){
      const limit = parseInt(event.target.options[event.target.options.selectedIndex].innerText)
      const response = await axios.get(`https://jsonplaceholder.typicode.com/todos/?_limit=${limit}`);
      console.log(response);
      this.allTodos = response.data;
    }
	},
};
</script>

<style>
body {
	font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;
	line-height: 1.6;
	background: #e8f7f0;
}
.container {
	max-width: 1100px;
	margin: auto;
	overflow: auto;
	padding: 0 2rem;
}
</style>

/* todos */
<style scoped>
.todos {
	display: grid;
	grid-template-columns: repeat(3, 1fr);
	grid-gap: 1rem;
}
.todo {
	border: 1px solid #ccc;
	background: #41b883;
	padding: 1rem;
	border-radius: 5px;
	text-align: center;
	position: relative;
	cursor: pointer;
}
i {
	position: absolute;
	bottom: 10px;
	right: 10px;
	color: #fff;
	cursor: pointer;
}
.legend {
	display: flex;
	justify-content: space-around;
	margin-bottom: 1rem;
}
.complete-box {
	display: inline-block;
	width: 10px;
	height: 10px;
	background: #35495e;
}
.incomplete-box {
	display: inline-block;
	width: 10px;
	height: 10px;
	background: #41b883;
}
.is-complete {
	background: #35495e;
	color: #fff;
}
@media (max-width: 500px) {
	.todos {
		grid-template-columns: 1fr;
	}
}
</style>
